# 图搜相关

适用于浏览器当中的插件程序

## Directory Layout
```shell
.
├── /_locales/                  # 语言支持
├── /html/                      # 插件页html
├── /css/       
│   ├── /img/                   # 样式图片
│   ├── ...                     # 样式
├── /script/                    # 页面图片
│   ├── jquery-2.1.1.min.js     # jquery
│   ├── drag-search.js          # 插件内嵌页逻辑
│   ├── tusou.js                # 插件创建逻辑
│   ├── content.js              # 插件交互逻辑
│── manifest.json               # 插件配置文件
│── README.md                   # Project overview / getting started guide
└── ...                         # 插件上线必要文件
```

> *注意不同浏览器打包的形式不同*

## 开发流程
1. 打开浏览器插件所在目录进行开发，示例：
- C:\Program Files\Google\Chrome\Application\plugins
- C:\Users\Admin\AppData\Local\Google\Chrome\User Data\Default\UnpackedExtensions

2. 生效方式：修改代码 → 刷新插件 → 刷新页面

3. 更新版本号：修改 mainfest.json、tusou.html, 修改[接口响应](https://stu.17zwd.com/api/version/tusouext)， 来自项目[17zwd/fe-egg-tusou](https://amiba.fun/17zwd/fe-egg-tusou)

4. 打包方式：chrome(dev版) 打开 chrome://extensions/ 运行打包扩展程序，选择仓库代码进行打包

## 用户教程
- https://www.17zwd.com/help/dianzhu/201708270308553660.htm
- [360安全浏览器](https://ext.se.360.cn/webstore/detail/ijkjnfkoneaenggcahefoaencbjgpegm)、[360极速浏览器](https://ext.chrome.360.cn/webstore/detail/ijkjnfkoneaenggcahefoaencbjgpegm) 要身份认证+审核暂停更，采用教程手动导入方式

## 更新方式
1. 上传到服务器 (e.g. https://public-17zwd.oss-cn-shenzhen.aliyuncs.com/tools/xxx)

2. 修改教程里下载链接 (下载链接相同时可能有缓存，插件下载链接后缀可以加 ?t=xxx 测试)


## 支持示例

- [淘宝/天猫商品](https://detail.tmall.com/item.htm?spm=a1z10.3-b-s.w4011-14630320223.74.1d525a369PTuqd&id=705136097150&rn=f3cf1b09379c327887462ff1119692af&abbucket=6)

- [抖店商品 ](https://haohuo.jinritemai.com/ecommerce/trade/detail/index.html?id=3577142414068027242&origin_type=604)


