window.addEventListener('load', function () {
  toastr &&
    (toastr.options = {
      closeButton: true,
      debug: false,
      newestOnTop: false,
      progressBar: false,
      positionClass: 'toast-top-center',
      preventDuplicates: true,
      onclick: null,
      showDuration: '100',
      timeOut: '100000',
      showEasing: 'swing',
      hideEasing: 'linear',
      showMethod: 'fadeIn',
      hideMethod: 'fadeOut',
      onclick: () => {
        window.open(
          'https://www.17zwd.com/help/dianzhu/201708270308553660.htm'
        );
      },
    });

  var tusouAPI = '//stu.17zwd.com/SearchSimilar?img_url=';
  var zwdDomain = 'http://gz.17zwd.com';
  var searchResult = 'http://stu.17zwd.com/search/';
  var zwdRegExp = /^https?:\/\/[a-z]+.17zwd.com/;
  var regUrlExt = /^(https?:)?\/\/.*\.(jpe?g|png)(\?(.*)?)?/i;
  var matchDomainArray = [
    'vvic.com',
    'tmall.com',
    'taobao.com',
    '1688.com',
    '17zwd.com',
  ];
  var inMatchDomain = false;
  var linkLayerCount = 3;
  var domainConfig = {
    'vvic.com': {
      domain: 'vvic.com',
      title: [
        ' - 搜款网 - 普宁站 - 真实档口一手货源',
        ' - 搜款网 - 真实档口一手货源',
      ],
      detail: '/item/',
      hasCategory: false,
      linkLayerCount: 3,
    },
    'tmall.com': {
      domain: 'tmall.com',
      title: ['-tmall.com天猫'],
      detail: '/item.htm',
      hasCategory: false,
      linkLayerCount: 3,
    },
    'taobao.com': {
      domain: 'taobao.com',
      title: ['-淘宝网'],
      detail: 'item.htm', //'click.simba.taobao.com' to do 跳转到商品详情页
      ck: true,
      ckLink: 'click.simba.taobao.com',
      hasCategory: false,
      linkLayerCount: 3,
    },
    '1688.com': {
      domain: '1688.com',
      title: [' 微商 - 阿里巴巴', ' - 阿里巴巴', '点击查看大图：'],
      detail: '/offer/', //to do dj.1688.com 跳转到商品详情页
      ck: true,
      ckLink: 'dj.1688.com',
      hasCategory: true,
      linkLayerCount: 6,
    },
    '17zwd.com': {
      domain: '17zwd.com',
      title: [' - 一起做网店[17zwd.com]', ' - 一起做网店'],
      detail: 'item.htm',
      hasCategory: true,
      linkLayerCount: 3,
    },
  };
  var tabLink = location.href;
  var tabDomain = location.hostname;
  tabDomain = tabDomain.substring(tabDomain.indexOf('.') + 1, tabDomain.length);
  if (domainConfig[tabDomain]) {
    inMatchDomain = true;
    linkLayerCount = domainConfig[tabDomain].linkLayerCount;
  }

  var filterImage = function (img) {
    var result = false,
      $img = img,
      imgWidth = $img.width(),
      imgHeight = $img.height(),
      imgScale = imgWidth / imgHeight,
      minWidth = 200,
      minHeight = 200,
      maxScale = 7 / 4,
      minScale = 4 / 7;

    // 获取图片宽度
    if (
      imgWidth >= minWidth &&
      imgHeight >= minHeight &&
      imgScale <= maxScale &&
      imgScale >= minScale
    ) {
      result = true;
    }
    return result;
  };

  var createImgbox = function (that, btnPosiClass) {
    var $item = that,
      _html = [],
      _src = '',
      _title = $item.attr('alt') || $item.attr('title') || '';
    if (zwdRegExp.test(location.href)) {
      _src = $item.attr('data-tusou-url') || $item.attr('src');
    } else {
      _src = $item.attr('src');
    }
    var $itemHeight = $item.height();
    $item.wrap(
      '<div class="ts-img-box" style="height:' + $itemHeight + 'px"></div>'
    );
    if (regUrlExt.test(_src)) {
      _html.push('<span class="ts-btn-search">搜图片</span>');
    }
    if (
      $item.parentsUntil('a').length < linkLayerCount &&
      $item.parentsUntil('a').length > 0
    ) {
      var $itemA = $item.closest('a'),
        _linkUrl = $itemA.attr('href'),
        _itemAtitle = $itemA.attr('alt') || $itemA.attr('title') || '';
      var _matchResult = matchLink(_linkUrl, _title, _itemAtitle);
      if (_matchResult) {
        _html.push(
          '<span class="ts-btn-nb" title="' + _itemAtitle + '">搜标题</span>'
        );
      }
    }
    if (_html.length) {
      $item.before(
        '<div class="va-btn-search ' +
          (btnPosiClass || '') +
          '">' +
          _html.join('') +
          '</div>'
      );
    }
  };

  /**创建准备
   *
   * @param DOM that
   * @param Object options
   * {
   *  // 图搜按钮位置样式
   *  btnPosiClass: '',
   *  // 过滤图片尺寸
   *  filterImgSize: true
   * }
   */
  var prepareForCreateImgbox = function (that, options) {
    var $this = that,
      $vaImgBox = $this.parents('.va-img-box'),
      $vaBtn = $vaImgBox.find('.va-btn');
    var { btnPosiClass, filterImgSize } = options || {};
    if ($vaImgBox.length > 0 && $vaBtn.length > 0) {
      $vaBtn.remove();
    }
    if ($this.parents('.ts-img-box').length == 0) {
      var imageStatus = true;
      if (filterImgSize) {
        imageStatus = filterImage($this);
      }
      if (imageStatus) {
        // 加个延迟有的网站比如天猫会在动态的添加元素，确保在添加之后再包裹image
        setTimeout(function () {
          createImgbox($this, btnPosiClass);
        }, 500);
      }
    } else {
      // $this.parents('.ts-img-box').siblings('.ks-imagezoom-lens').css('position', 'static')
      // 修复淘宝网商品详情页bug
    }
  };

  $(document.body).append(
    '<a id="vaGo" href="javascript:;" target="_blank"></a>'
  );

  $(document).on('mouseover', 'img', function () {
    prepareForCreateImgbox($(this), {
      filterImgSize: true,
    });
  });

  /** 淘宝商品页主图(侧边)DOM兼容 */
  $(document).on('mouseover', '.pageContentWrap ul:first li', function () {
    $(this)
      .find('img')
      .each(function (i, elem) {
        prepareForCreateImgbox($(elem), {
          btnPosiClass: 'va-btn-search-tb',
        });
      });
  });

  /** 淘宝档口页商品列表图DOM兼容 */
  $('div[data-spm]').each(function () {
    if ($(this).data('spm') !== 'product_shelf') return;
    $(this)
      .find('img')
      .each(function (i, elem) {
        prepareForCreateImgbox($(elem), {
          btnPosiClass: 'va-btn-search-tb',
        });
      });
  });

  $(document)
    .on('click', '.ts-btn-search', function (event) {
      event.stopPropagation();
      event.preventDefault();
      // console.log($('.ts-img-box').children('img'))
      // var srcUrl = $('.ts-img-box').children('img').attr('src')
      // var srcUrl = $(this).parent().next('img').attr('src');
      var srcUrl = $(this).parents('.ts-img-box').find('img').attr('src');
      if (!srcUrl) {
      }
      searchByImage(srcUrl);
    })
    .on('click', '.ts-btn-nb', function (event) {
      event.stopPropagation();
      event.preventDefault();
      var $link = $(this).closest('a'),
        $img = $(this).parent().next('img'),
        linkUrl = $link.attr('href'),
        linkTitle = $link.attr('title') || '',
        imgTitle = $img.attr('title') || $img.attr('alt') || '';
      if (linkTitle != '') {
        var pageTitle = handleTitle(linkTitle, location.hostname, true);
        searchByTitle(pageTitle);
      } else {
        if (imgTitle != '') {
          var pageTitle = handleTitle(imgTitle, location.hostname, true);
          searchByTitle(pageTitle);
        } else {
          var reg = /^(https?:)?\/\//i;
          if (linkUrl.match(reg) == null) {
            linkUrl = location.hostname + '/' + linkUrl;
            linkUrl = linkUrl.replace(/\/\//g, '/');
            linkUrl = location.protocol + '//' + linkUrl;
          } else {
            linkUrl = linkUrl.replace(/^https?:/, '');
          }
          searchByLink(linkUrl);
        }
      }
    })
    .on('click', '.btn-search-img', function (event) {
      event.stopPropagation();
      event.preventDefault();
      var srcUrl = $(this).parent().find('img').attr('src');
      searchByImage(srcUrl);
    });

  function searchByImage(srcUrl) {
    var _src = handleAliUrl(srcUrl);
    var _url = 'https:' + tusouAPI + encodeURIComponent(_src);
    chrome.extension.sendRequest(
      {
        type: 'searchImage',
        url: _url,
      },
      function (response) {
        _tusouLogger(response.farewell);
      }
    );
  }

  function searchByLink(linkUrl) {
    chrome.extension.sendRequest(
      {
        type: 'getPageByLink',
        link: 'https:' + linkUrl,
      },
      function (response) {
        if (!!response) {
          const { data: pageHtmlSouce } = response;
          let pageTitle = pageHtmlSouce.match(/<title>.+<\/title>/i);
          pageTitle = handleTitle(pageTitle[0], linkUrl);
          searchByTitle(pageTitle);
        }
      }
    );
  }

  var searchByTitle = function (linkTitle) {
    var _url = zwdDomain + '/sks.htm?so=' + encodeURIComponent(linkTitle);
    // var _a = document.createElement('a');
    // _a.setAttribute('href', _url);
    // _a.setAttribute('target', '_blank');
    // _a.setAttribute('id', 'windonGoHref');
    // // 防止反复添加
    // if (!document.getElementById('windonGoHref')) {
    //     document.body.appendChild(_a);
    // }
    // _a.click();
    window.open(_url);
  };

  // 针对一些阿里cdn特殊图片链接进行处理。
  var handleAliUrl = function (url, tab) {
    let res = url;
    res = res.replace(/\?.*$/, ''); // 移除问号及其后的所有内容
    res = res.replace(/_([0-9]+(x|-)[0-9]+)?\.?(jpe?g|png|.webp)(\.webp)?/, ''); // _480x480.webp _400x400.jpg.webp _.webp
    res = res.replace(/_?q\d+(s?\d+)?\.(jpe?g|png)/, ''); // _q30.jpg
    if (res.indexOf('//') == 0) {
      res = window.location.protocol + res;
    }
    return res;
  };

  var handleTitle = function (title, url, isalt) {
    var _title = title;
    if (!isalt) {
      _title = _title.replace(/<\/?title>/g, '');
    }
    for (var i = 0; i < matchDomainArray.length; i++) {
      var _matchItem = domainConfig[matchDomainArray[i]],
        _reg = new RegExp(_matchItem.domain, 'gi');
      if (_reg.test(url)) {
        for (var j = 0; j < _matchItem.title.length; j++) {
          _title = _title.replace(_matchItem.title[j], '');
        }
        if (_matchItem.hasCategory && !isalt) {
          var _titleArray = _title.split(' ');
          _titleArray.length = _titleArray.length - 1;
          _title = _titleArray.join('');
        }
      } else {
        continue;
      }
    }
    return _title;
  };

  var matchLink = function (detailLink, imgAlt, linkTitle) {
    var _result = false,
      _isMatch = false;
    for (var i = 0; i < matchDomainArray.length; i++) {
      if (_result) {
        continue;
      }
      var _item = domainConfig[matchDomainArray[i]];
      var _detail = inMatchDomain ? _item.detail : _item.domain + _item.detail,
        _reg = new RegExp(_detail, 'gi');
      if (_reg.test(detailLink)) {
        _result = true;
      }
      if (_item.ck) {
        _reg = new RegExp(_item.ckLink, 'gi');
        if (_reg.test(detailLink) && (imgAlt != '' || linkTitle != '')) {
          _result = true;
        }
      }
    }
    return _result;
  };

  /** 页面加载完成后，请求接口判断插件版本 */
  const checkExtUpdate = function () {
    chrome.extension.sendRequest(
      {
        type: 'checkUpdate',
      },
      response => {
        _tusouLogger(response);
        const { data } = response;
        if (data && data.desc) {
          toastr['info'](data.desc);
        }
      }
    );
  };
  checkExtUpdate();
});
